/* LED blink tool (C) 2002-11-11 Georg Lukas <georg@boerde.de>
 * 
 * WARNING: This is only a quick hack. YOU GET NO WARRANTY!!
 *
 * Ok, this little tool has three modi of operation:
 *
 * $ blink	- resets the LED to permanent orange
 * $ blink X Y	- sets LED mode to X and register to Y (if you have fun
 * 		  experimenting with the possibilities on a low level...)
 * $ blink xxxx	- each x can be:
 * 			g = green
 * 			o = orange
 * 			r = red
 * 			everything else = off
 * 		  this allows to specify a sequence of four colors which are
 * 		  displayed in a loop. try "blink rogo" for weird traffic
 * 		  lights ;-)
 *
 * 		  					Georg
 * */

#include <fcntl.h>
#include <i2c-dev.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "xbox.h"

/*
collected knowledge:
from xbeboot/load.c:
        HalWriteSMBusValue(0x20, 0x08, FALSE, 0xff);
	HalWriteSMBusValue(0x20, 0x07, FALSE, 0x01);

former xbeboot/header.S:
- #define LED_RED_C0    0x80
- #define LED_RED_C1    0x40
- #define LED_RED_C2    0x20
- #define LED_RED_C3    0x10
- #define LED_GREEN_C0  0x08
- #define LED_GREEN_C1  0x04
- #define LED_GREEN_C2  0x02
- #define LED_GREEN_C3  0x01

*/

int main(int argc, char *argv[]) {
	char *fname = "/dev/i2c/0";
	char *x;
	int fd, mode, reg, r, g;

	if ((argc==2) && (strlen(argv[1])==4)) {
		mode = 1;
		x = argv[1];
		r = g = 0;
		while (*x) {
			r *= 2;
			g *= 2;
			switch (*x) {
			case 'r' : r++; break;
			case 'g' : g++; break;
			case 'o' : r++; g++; break;
			}
			x++;
		}
		//printf("collected flags: r=%02x g=%02x\n", r, g);
		reg = ((r<<4) & 0xF0) + (g & 0xF);
	} else if (argc > 2) {
		mode = atoi(argv[1]);
		reg = atoi(argv[2]);
	} else {
		mode = 1;
		reg = 0xff;
	}
	if ((fd = open(fname, O_RDWR)) < 0) {
		fprintf(stderr, "Error in open(%s): %s\n", fname, strerror(errno));
		return 1;
	}

	if (ioctl(fd,I2C_SLAVE_FORCE,PIC_ADDRESS) < 0) {
		fprintf(stderr,"Error: Could not set address to %d: %s\n",PIC_ADDRESS,strerror(errno));
		return 2;
	}

	//printf("Writing mode %i; reg 0x%02x...\n", mode, reg);
	i2c_smbus_write_byte_data(fd,SMC_CMD_LED_MODE,mode);
	i2c_smbus_write_byte_data(fd,SMC_CMD_LED_REGISTER,reg);

	close(fd);

	return 0;
}
