#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <i2c-dev.h>
#include "xbox.h"

int main(int argvc, char *argv[]) {

	int res_1c = 0,res_1d = 0,res_1e = 0,res_1f = 0;
	int t1 = 0,t2 = 0, byte1 = 0, byte2 = 0;
	int i = 0,file,i2cbus;
	char filename1[20];

	i2cbus = 0;
//	10 w: 1C 
//	10 r: 52  <-- res_1C
//	10 w: 1D 
//	10 r: 72  <-- res_1D
//	10 w: 1E 
//	10 r: EA  <-- res_1E
//	10 w: 1F 
//	10 r: 46  <-- res_1F
//	10 w: 20 40  <-- 20 byte1
//	10 w: 21 7D  <-- 21 byte2
//	10 w: 01 00  <-- 01 00
		
	sprintf(filename1,"/dev/i2c/%d",i2cbus);

	if ((file = open(filename1,O_RDWR)) < 0) {
		    exit(1);
	}
	if (ioctl(file,I2C_SLAVE_FORCE,PIC_ADDRESS) < 0) {
		fprintf(stderr,"Error: Could not set address to %d: %s\n",PIC_ADDRESS,
		              strerror(errno));
		exit(1);
	}

	res_1c = i2c_smbus_write_byte(file,0x1c);
	res_1c = i2c_smbus_read_byte_data(file,0x1c);
	res_1d = i2c_smbus_write_byte(file,0x1d);
	res_1d = i2c_smbus_read_byte_data(file,0x1d);
	res_1e = i2c_smbus_write_byte(file,0x1e);
	res_1e = i2c_smbus_read_byte_data(file,0x1e);
	res_1f = i2c_smbus_write_byte(file,0x1f);
	res_1f = i2c_smbus_read_byte_data(file,0x1f);
		
	t1 = (res_1c << 2) ^ (res_1d + 0x39) ^ (res_1e >> 2) ^ (res_1f + 0x63);
	t2 = (res_1c + 0x0b) ^ (res_1d >> 2) ^ (res_1e + 0x1b);
	byte1 = 0x33;
	byte2 = 0xed;
	for (i=0; i < 4; i++ ) {
		byte1 += byte2 ^ t1;
		byte2 += byte1 ^ t2;
	}

	byte1 &= 255;
	byte2 &= 255;

	i2c_smbus_write_byte_data(file,0x20,byte1);
	i2c_smbus_write_byte_data(file,0x21,byte2);
	i2c_smbus_write_byte_data(file,0x01,0x00);

//	printf("%02x %02x %02x %02x --> %02x %02x\n",res_1c,res_1d,res_1e,res_1f,byte1,byte2);
	exit(0);
}
